/***************************************************************************
 * Name:      Music_Organizer__App.cpp                                     *
 * Purpose:   Code for Application Class                                   *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-11-26                                                   *
 * Copyright: Jackie Team (http://www.musicorganizer.org)                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "Music_Organizer__App.h"
#include "Music_Organizer__Main.h"

IMPLEMENT_APP(Music_Organizer__App);

bool Music_Organizer__App::OnInit() {
    SetVendorName(_T("Jackie Team"));
    SetAppName(_T("Music_Organizer"));
    //With wxMac the generic listctrl must be used to allow dragging and folder sorting
    wxSystemOptions::SetOption(_T("mac.listctrl.always_use_generic"),1);
    wxString op,path=wxEmptyString;
    if(argc==3) { //check if a valid options is given
        op=wxString(argv[1]);
        if(op==_T("-p") || op==_T("--path"))//then the path should be changed
            path=wxString(argv[2]);
    }

    Music_Organizer__Frame* frame = new Music_Organizer__Frame(0L, _T("Music Organizer"));
    if(path!=wxEmptyString)
        frame->SetPath(path);

    bool frameMaximized = OptionsHandler::getOption(_T("/app/frameMaximized"),false);
    if (frameMaximized)
        frame->Maximize();
    else {
        int frameWidth = OptionsHandler::getOption(_T("/app/frameWidth"),-1);
        int frameHeight = OptionsHandler::getOption(_T("/app/frameHeight"),-1);
        int frameX = OptionsHandler::getOption(_T("/app/frameX"),-1);
        int frameY = OptionsHandler::getOption(_T("/app/frameY"),-1);

        if (frameWidth < 0 || frameWidth > wxSystemSettings::GetMetric(wxSYS_SCREEN_X) || frameHeight < 0 || frameHeight > wxSystemSettings::GetMetric(wxSYS_SCREEN_Y)) {
            frame->Center();
        } else if(frameX < 0 || frameX > wxSystemSettings::GetMetric(wxSYS_SCREEN_X) || frameY < 0 || frameY > wxSystemSettings::GetMetric(wxSYS_SCREEN_Y)) {
            frame->Maximize();
        } else {
            frame->SetSize(frameX, frameY, frameWidth, frameHeight);
        }
    }
    frame->Show();

    //With this, it is possible to launch update in a thread
    wxSocketBase::Initialize();

    UpdateThread* t = new UpdateThread();
    t->Create();
    t->Run();

    SetTopWindow(frame);

    return true;
}
